Codeforces 479E Riding in a Lift【Dp+前缀和优化+二分】好题~

351 篇文章 2 订阅
142 篇文章 0 订阅

E. Riding in a Lift
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Imagine that you are in a building that has exactly n floors. You can move between the floors in a lift. Let's number the floors from bottom to top with integers from 1 to n. Now you're on the floor number a. You are very bored, so you want to take the lift. Floor number b has a secret lab, the entry is forbidden. However, you already are in the mood and decide to make k consecutive trips in the lift.

Let us suppose that at the moment you are on the floor number x (initially, you were on floor a). For another trip between floors you choose some floor with number y (y ≠ x) and the lift travels to this floor. As you cannot visit floor b with the secret lab, you decided that the distance from the current floor x to the chosen y must be strictly less than the distance from the current floor x to floor b with the secret lab. Formally, it means that the following inequation must fulfill: |x - y| < |x - b|. After the lift successfully transports you to floor y, you write down number yin your notepad.

Your task is to find the number of distinct number sequences that you could have written in the notebook as the result of k trips in the lift. As the sought number of trips can be rather large, find the remainder after dividing the number by 1000000007 (109 + 7).

Input

The first line of the input contains four space-separated integers nabk (2 ≤ n ≤ 50001 ≤ k ≤ 50001 ≤ a, b ≤ na ≠ b).

Output

Print a single integer — the remainder after dividing the sought number of sequences by 1000000007 (109 + 7).

Examples
input
5 2 4 1
output
2
input
5 2 4 2
output
2
input
5 3 4 1
output
0
Note

Two sequences p1, p2, ..., pk and q1, q2, ..., qk are distinct, if there is such integer j (1 ≤ j ≤ k), that pj ≠ qj.

Notes to the samples:

  1. In the first sample after the first trip you are either on floor 1, or on floor 3, because |1 - 2| < |2 - 4| and |3 - 2| < |2 - 4|.
  2. In the second sample there are two possible sequences: (1, 2)(1, 3). You cannot choose floor 3 for the first trip because in this case no floor can be the floor for the second trip.
  3. In the third sample there are no sought sequences, because you cannot choose the floor for the first trip.

题目大意:

给你N层楼,其中起始在位子a.其中有一层b不能走,如果现在在位子x.那么走到的下一个位子y需要满足:|x - y| < |x - b|

问一共走K次会有多少种走法。


思路:


1、统计方案数问题,一步的状态影响另外一步的状态,那么考虑dp.设定dp【i】【j】表示第i步走到了位子j的方案数。

那么有:dp【i】【j】+=dp【i-1】【u】(需要满足abs|u-y|<abs|u-b|);

那么很显然,时间复杂度是要O(n^3)的。

仔细想想不难发现,如果有这样一种情况,那么蓝色部分就是可行u的部分:


很显然结果是连续的,那么我们考虑前缀和来优化问题。


2、既然选择了前缀和优化,那么时间复杂度也能从O(n^3)降到O(n^2)了.接下来的任务就是分类讨论并且搞定状态转移即可。

一个图确定思路(j<b的情况):


相反,如果j>b的部分我们也可以同理处理。

具体实现部分参考代码。


Ac代码:

#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;
#define mod 1000000007
int dp[5005][5005];
int sum[5005][5005];
int main()
{
    int n,a,b,k;
    while(~scanf("%d%d%d%d",&n,&a,&b,&k))
    {
        memset(sum,0,sizeof(sum));
        memset(dp,0,sizeof(dp));
        dp[0][a]=1;
        for(int i=1;i<=n;i++)sum[0][i]=sum[0][i-1]+dp[0][i],sum[0][i]%=mod;
        for(int i=1;i<=k;i++)
        {
            for(int j=1;j<=n;j++)
            {
                if(j==b)continue;
                if(b>j)
                {
                    dp[i][j]+=(sum[i-1][j-1])%mod;
                    dp[i][j]%=mod;
                    int ans=-1;
                    int l=j+1;
                    int r=b-1;
                    while(r-l>=0)
                    {
                        int mid=(l+r)/2;
                        if(abs(j-mid)<abs(mid-b))
                        {
                            ans=mid;
                            l=mid+1;
                        }
                        else r=mid-1;
                    }
                    if(ans!=-1)dp[i][j]+=(sum[i-1][ans]-sum[i-1][j])%mod;
                    dp[i][j]%=mod;
                }
                if(b<j)
                {
                    dp[i][j]+=(sum[i-1][n]-sum[i-1][j])%mod;
                    dp[i][j]%=mod;
                    int ans=-1;
                    int l=b+1;
                    int r=j-1;
                    while(r-l>=0)
                    {
                        int mid=(l+r)/2;
                        if(abs(j-mid)<abs(mid-b))
                        {
                            ans=mid;
                            r=mid-1;
                        }
                        else l=mid+1;
                    }
                    if(ans!=-1)dp[i][j]+=(sum[i-1][j-1]-sum[i-1][ans-1])%mod;
                    dp[i][j]%=mod;
                }
            }
            for(int j=1;j<=n;j++)
            {
                sum[i][j]=(sum[i][j-1]+dp[i][j])%mod;
                sum[i][j]%=mod;
            }
        }
        int ans=0;
        for(int i=1;i<=n;i++)
        {
            ans+=dp[k][i];
            ans%=mod;
        }
        printf("%d\n",(ans+mod)%mod);
    }
}









  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值